#ifndef TaxiwaySelection_h
#define TaxiwaySelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include "PavementSelection.h"
#include "TaxiwayMapObject.h"


class TaxiwaySelection: public PavementSelection {
        
        DECLARE_CLASS(TaxiwaySelection)
        
public:
	TaxiwaySelection(MapSelectionManager* manager, TaxiwayMapObject* content);

        virtual ~TaxiwaySelection();
        
        virtual wxString EndDrag() {
                return wxT("Moving Taxiway");
        }
        
        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        TaxiwayMapObject* GetContent() const { return wxDynamicCast(PavementSelection::GetContent(),TaxiwayMapObject); }
};

#endif


