#ifndef TowerSelection_h
#define TowerSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include "PointObjectSelection.h"
#include "TowerMapObject.h"


class TowerSelection: public PointObjectSelection {
        
        DECLARE_CLASS(TowerSelection)
        
public:
	TowerSelection(MapSelectionManager* manager, TowerMapObject* content);

        virtual ~TowerSelection();
        
        virtual wxString EndDrag() {
                return wxT("Moving Tower Viewpoint");
        }
        
        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        TowerMapObject* GetContent() const { return wxDynamicCast(PointObjectSelection::GetContent(),TowerMapObject); }
};

#endif


