#ifndef MapCalibratedBackgroundImageSelection_h
#define MapCalibratedBackgroundImageSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include "MapSimpleBackgroundImageSelection.h"
#include "MapCalibratedBackgroundImage.h"


class MapCalibratedBackgroundImageSelection: public MapSimpleBackgroundImageSelection {
        
        DECLARE_CLASS(MapCalibratedBackgroundImageSelection)
        
public:
	MapCalibratedBackgroundImageSelection(MapSelectionManager* manager, MapCalibratedBackgroundImage* content);

        virtual ~MapCalibratedBackgroundImageSelection();
        
        virtual void ProvideActionMenuForClass(wxMenu& actionMenu, wxClassInfo* targetClass);

        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        MapCalibratedBackgroundImage* GetContent() const { return wxDynamicCast((MapObject*)MapSimpleBackgroundImageSelection::GetContent(),MapCalibratedBackgroundImage); }
};

#endif


