#include "MapPropertiesFrame.h"

#include <Airport/AirportPropertyEditor.h>

#include <Map/MapEditor.h>
#include <Map/MapObjectPropertyManager.h>

IMPLEMENT_CLASS(MapPropertiesFrame,wxFrame);

BEGIN_EVENT_TABLE(MapPropertiesFrame, wxFrame)
        EVT_CLOSE(MapPropertiesFrame::OnClose)
END_EVENT_TABLE()

MapPropertiesFrame::MapPropertiesFrame(wxWindow* parent,
                                       wxWindowID id,
                                       MapEditor* editor,
                                       const Airport::SmartRef& airport,
                                       const wxString& title,
                                       const wxPoint& pos,
                                       const wxSize& size,
                                       long style,
                                       const wxString& name):
        wxFrame(parent,id,title,pos,size,style,name)
{
        _propertyNotebook=new wxNotebook(this,wxID_ANY);
        
        _objectPropertyWindow=new wxPropertyGrid(_propertyNotebook);
        _objectPropertyWindow->SetExtraStyle( wxPG_EX_HELP_AS_TOOLTIPS );
        _objectPropertyWindow->SetWindowStyleFlag(wxTAB_TRAVERSAL);
        _propertyNotebook->AddPage(_objectPropertyWindow,wxT("Object"));
        
        AirportPropertyEditor *_airportPropertyEditor;
        
        _airportPropertyEditor=new AirportPropertyEditor(_propertyNotebook,airport);
        
        _propertyNotebook->AddPage(_airportPropertyEditor,wxT("Airport"));
        _objectPropertyManager=new MapObjectPropertyManager(editor,_objectPropertyWindow);
}

MapPropertiesFrame::~MapPropertiesFrame() {
}

void MapPropertiesFrame::OnClose(wxCloseEvent& evt) {
        if (!evt.CanVeto()) {
                evt.Skip();
                return;
        }
        Show(false);
}

