#ifndef MapPropertiesFrame_h
#define MapPropertiesFrame_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Airport/Airport.h>

#include <wx/notebook.h>
#include <wx/propgrid/propgrid.h>

class MapEditor;
class MapObjectPropertyManager;

class MapPropertiesFrame: public wxFrame {
        
        DECLARE_CLASS(MapPropertiesFrame)
        
public:
        enum { DefaultStyle =  wxRESIZE_BORDER |
                               wxCAPTION |
                               wxCLOSE_BOX |
                               wxCLIP_CHILDREN|
                               wxFRAME_TOOL_WINDOW |
                               wxFRAME_NO_TASKBAR |
                               wxFRAME_FLOAT_ON_PARENT };
        
	MapPropertiesFrame(wxWindow* parent,
                           wxWindowID id,
                           MapEditor* editor,
                           const Airport::SmartRef& airport,
                           const wxString& title,
                           const wxPoint& pos = wxDefaultPosition,
                           const wxSize& size = wxSize(240,480),
                           long style = DefaultStyle,
                           const wxString& name = wxT("properties_frame"));
        virtual ~MapPropertiesFrame();
        
        void OnClose(wxCloseEvent& evt);
protected:
        wxNotebook* _propertyNotebook;
        
        wxPropertyGrid *_objectPropertyWindow;
        wxPropertyGrid *_airportPropertyWindow;
        MapObjectPropertyManager *_objectPropertyManager;
private:
        DECLARE_EVENT_TABLE()
};

#endif

