#ifndef MapStatusBar_h
#define MapStatusBar_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

class MapStatusBar: public wxStatusBar {
        
        DECLARE_CLASS(MapStatusBar)
        
public:
	MapStatusBar();
        MapStatusBar(wxWindow* parent, wxWindowID id, long style = wxST_SIZEGRIP, const wxString& name = wxT("statusBar"));
        virtual ~MapStatusBar();
        
        void OnSize(wxSizeEvent& evt);
        
        void SetProgressLabel(const wxString& label);
        
        void SetProgress(int done, int total);
protected:
        void Setup();
        
        void UpdateProgressText();
        
        void ShowProgress(bool show);
        
        wxSizer* _gaugeSizer;
        wxGauge* _gauge;
        wxStaticText* _gaugeText;
        wxString _gaugeLabel;
        
        unsigned int _done,_total;
        
        DECLARE_EVENT_TABLE()
};

#endif

