#ifndef TransactionObjectLifetimeObserver_h
#define TransactionObjectLifetimeObserver_h

class TransactionObject;

/**
 * \brief A TransactionObjectLifetimeObserver is informed when the
 * lifetime of a TransactionObject ends.
 *
 * See \ref transaction_concept for more information.
 *
 * \todo Actually implement calling the observers when the lifetime ends.
 */
class TransactionObjectLifetimeObserver {
public:
        /**
         * \brief React to the end of the lifetime of the given object.
         *
         * This method is called when the lifetime of an object this
         * observer was registered to ends.
         */
        virtual void LifetimeEnds(TransactionObject* object)=0;
};

#endif

