#include "UndoRedoMenuManager.h"

#include "Transaction.h"
#include "TransactionManager.h"

IMPLEMENT_CLASS(UndoRedoMenuManager,wxEvtHandler);

BEGIN_EVENT_TABLE(UndoRedoMenuManager,wxEvtHandler)
        EVT_MENU(wxID_ANY,UndoRedoMenuManager::OnMenuSelected)
END_EVENT_TABLE()

UndoRedoMenuManager::UndoRedoMenuManager(TransactionManager* tmgr,
                                         MenuType type):
        wxEvtHandler(),
        _transactionManager(tmgr),
        _type(type)
{
}

UndoRedoMenuManager::~UndoRedoMenuManager() {
}


void UndoRedoMenuManager::SetupMenu(wxMenu* menu) {
        wxMenuItemList list=menu->GetMenuItems();
        wxMenuItemList::Node *listNode;
        for (listNode=list.GetFirst();listNode;listNode=listNode->GetNext()) {
                menu->Destroy(listNode->GetData());
        }
        
        switch (_type) {
        case MenuType_Undo:
                for (size_t idx=0;idx<_transactionManager->GetUndoSteps();idx++) {
                        const wxString& desc=_transactionManager->GetUndoDescription(idx);
                        menu->Append(idx,desc);
                }
                break;
        case MenuType_Redo:
                for (size_t idx=0;idx<_transactionManager->GetRedoSteps();idx++) {
                        const wxString& desc=_transactionManager->GetRedoDescription(idx);
                        menu->Append(idx,desc);
                }
                break;
        }
        
        menu->SetEventHandler(this);
}

void UndoRedoMenuManager::OnMenuSelected(wxCommandEvent& evt) {
        size_t idx=(size_t)evt.GetId()+1;
        switch (_type) {
        case MenuType_Undo:
                while (idx-->0) {
                        _transactionManager->Undo();
                }
                break;
        case MenuType_Redo:
                while (idx-->0) {
                        _transactionManager->Redo();
                }
                break;
        }
}

